"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _constants = require("../utils/constants");

var _CalendarRowItem = _interopRequireDefault(require("./CalendarRowItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var CalendarRow = function CalendarRow(props) {
  return React.createElement("div", {
    className: "awesome-react-datepicker-_CalendarRow",
    style: {
      height: props.isFiveRows ? 'calc(100% / 5)' : 'calc(100% / 6)'
    }
  }, _constants.sevenLengthArr.map(function (x, i) {
    var dateStamp = props.dateDistMap[i + props.index * 7];
    return React.createElement(_CalendarRowItem.default, {
      key: i,
      index: i,
      rowIndex: props.index // Index of the Parent Row
      ,
      isFiveRows: props.isFiveRows,
      year: props.year,
      month: props.month,
      date: new Date(dateStamp).getDate() // Date
      ,
      dateStamp: dateStamp // Date Timestamp
      ,
      dateDistMap: props.dateDistMap // { dateDistMap } from Props
      ,
      dateDistMapInverse: props.dateDistMapInverse // { dateDistMap } from Props
      ,
      onDateSelect: props.onDateSelect,
      initDate: props.initDate,
      customStyles: props.customStyles
    });
  }));
};

var _default = CalendarRow;
exports.default = _default;