"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _fa = require("react-icons/fa");

var _reactDropdownModal = _interopRequireDefault(require("react-dropdown-modal"));

var _funcs = require("../utils/funcs");

var _constants = require("../utils/constants");

var _Calendar = _interopRequireDefault(require("./Calendar"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Datepicker =
/*#__PURE__*/
function (_Component) {
  _inherits(Datepicker, _Component);

  function Datepicker(props) {
    var _this;

    _classCallCheck(this, Datepicker);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Datepicker).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleNavigation", function (bool) {
      _this.setState(function (_ref) {
        var year = _ref.year,
            month = _ref.month;
        return {
          year: (0, _funcs.funcHandleYear)(year, month, bool),
          month: (0, _funcs.funcHandleMonth)(month, bool)
        };
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getBoundingClient", function (id) {
      if (!document) return false;else {
        var rect = document.querySelector("#".concat(id)) ? document.querySelector("#".concat(id)).getBoundingClientRect() : false; // console.log(rect);

        return rect;
      }
    });

    var date = props.initDate ? props.initDate : new Date();
    _this.state = {
      year: date.getFullYear(),
      month: date.getMonth(),
      visCalendar: false,
      screenX: null,
      screenY: null,
      windowHeightDiff: 0
    };
    return _this;
  }

  _createClass(Datepicker, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state = this.state,
          year = _this$state.year,
          month = _this$state.month,
          screenX = _this$state.screenX,
          screenY = _this$state.screenY,
          windowHeightDiff = _this$state.windowHeightDiff;
      var _this$props = this.props,
          textColor = _this$props.textColor,
          borderColor = _this$props.borderColor,
          borderRadius = _this$props.borderRadius,
          themeColor = _this$props.themeColor,
          hoverBackground = _this$props.hoverBackground,
          backgroundColor = _this$props.backgroundColor,
          customZIndex = _this$props.customZIndex;
      var onDateSelect = this.props.onDateSelect;
      if (!onDateSelect) console.warn('\'onDateSelect\'(function) prop is required');
      var initDate;
      if (this.props.initDate) initDate = this.props.initDate;else {
        console.warn('\'initDate\' prop is required');
        initDate = new Date();
      }
      var customStyles = {
        textColor: textColor,
        borderColor: borderColor,
        borderRadius: borderRadius,
        themeColor: themeColor,
        hoverBackground: hoverBackground,
        backgroundColor: backgroundColor
      };
      return React.createElement(_reactDropdownModal.default, {
        visible: this.state.visCalendar,
        onButtonClick: function onButtonClick(e) {
          var windowHeightDiff = window ? window.outerHeight - window.innerHeight : 0;

          _this2.setState({
            screenX: e.screenX,
            screenY: e.screenY,
            windowHeightDiff: windowHeightDiff,
            visCalendar: true
          });
        },
        onClose: function onClose() {
          _this2.setState({
            screenX: null,
            screenY: null,
            visCalendar: false
          });
        },
        showArrow: true,
        arrowPosition: {
          right: '0px'
        },
        customZIndex: customZIndex || 20,
        position: {
          left: document && document.documentElement.offsetWidth - screenX < 222 ? screenX - 222 : screenX,
          bottom: screenY < 380 ? "calc(100vh - ".concat(screenY - windowHeightDiff + 257, "px)") : "calc(100vh - ".concat(screenY - windowHeightDiff, "px)")
        },
        modalContent: function modalContent() {
          return React.createElement("div", {
            className: "kcjajcnjacjhn",
            style: {
              border: borderColor ? borderColor : '1px solid #bbbbbb',
              color: textColor ? textColor : '#606060',
              borderRadius: borderRadius ? borderRadius : '3px',
              background: backgroundColor ? backgroundColor : 'white'
            },
            onClick: function onClick(e) {
              return e.stopPropagation();
            }
          }, React.createElement("div", {
            className: "awesome-react-datepicker-_Navigator",
            style: {
              background: backgroundColor ? backgroundColor : 'white'
            }
          }, React.createElement("h3", {
            className: "awesome-react-datepicker-_Navigator_h3_001"
          }, _constants.namesOfMonths[month], " ", year), React.createElement("div", {
            className: "awesome-react-datepicker-_Navigator_div_002"
          }, React.createElement("button", {
            className: "awesome-react-datepicker-_Navigator_btn_003",
            style: {
              background: backgroundColor ? backgroundColor : 'white',
              color: textColor ? textColor : '#606060'
            },
            onClick: function onClick() {
              return _this2.handleNavigation(false);
            }
          }, React.createElement(_fa.FaChevronLeft, null)), React.createElement("button", {
            className: "awesome-react-datepicker-_Navigator_btn_003",
            style: {
              background: backgroundColor ? backgroundColor : 'white',
              color: textColor ? textColor : '#606060'
            },
            onClick: function onClick() {
              return _this2.handleNavigation(true);
            }
          }, React.createElement(_fa.FaChevronRight, null)))), React.createElement(_Calendar.default, {
            year: year,
            month: month,
            onDateSelect: function (_onDateSelect) {
              function onDateSelect(_x) {
                return _onDateSelect.apply(this, arguments);
              }

              onDateSelect.toString = function () {
                return _onDateSelect.toString();
              };

              return onDateSelect;
            }(function (dateStamp) {
              if (!onDateSelect) _this2.setState({
                visCalendar: false
              });else {
                onDateSelect(dateStamp);

                _this2.setState({
                  visCalendar: false
                });
              }
            }),
            initDate: initDate,
            customStyles: customStyles
          }));
        }
      }, React.createElement("div", {
        className: "awesome-react-datepicker-_Dateinput",
        onClick: function onClick() {
          _this2.setState(function (prevState) {
            return {
              visCalendar: !prevState.visCalendar
            };
          });
        }
      }, this.props.children ? React.createElement(React.Fragment, null, this.props.children) : React.createElement("p", {
        className: "awesome-react-datepicker-_Dateinput_p_001",
        style: {
          color: textColor ? textColor : '#606060',
          border: borderColor ? borderColor : '1px solid #bbbbbb',
          borderRadius: borderRadius ? borderRadius : '3px'
        }
      }, initDate.getDate(), " ", _constants.namesOfMonths[initDate.getMonth()], ", ", initDate.getFullYear())));
    }
  }]);

  return Datepicker;
}(React.Component);

var _default = Datepicker;
exports.default = _default;